﻿using Bridge;
using Bridge.Html5;
using FrontendRouting;
using LearnBridgeNet.Components;
using Logging;
using PseudoHotReload;
using System.Collections.Generic;

namespace LearnBridgeNet
{
    internal class App
    {
        [Init(InitPosition.Top)]
        public static void Start()
        {
            Window.AddEventListener(EventType.Load, () =>
            {
                Window.Document.Body.InnerHTML = ""; // clear loading ui
                LazyMain(); // real main entry
            });
        }

        internal static PhrPollFile Phr;
        internal static NavigateBar NavigateBar;

        private static void LazyMain()
        {
            Logger.EnableDebug = true;
            Phr = new PhrPollFile("resources/phr-stamp.txt");

            FeRoutingViewsFinder<App>.RegisterAllView();

            NavigateBar = new NavigateBar(Window.Document.Body)
            {
                Items = new Dictionary<string, NavigateBarItem>
                {
                    {"/",new NavigateBarItem( "Home") },
                    {"/demo.html",new NavigateBarItem("Demo" )  },
                    {"/editor.html",new NavigateBarItem("Editor" )  },
                    {"/logoff.html",new NavigateBarItem("Logoff" ,true) }
                }
            };

            var routingContainer = new HTMLDivElement
            {
                ClassName = "page-container"
            };

            Window.Document.Body.AppendChild(routingContainer);

            FeRoutingManager.ParentNode = routingContainer;
            FeRoutingManager.Run();
        }
    }
}