﻿using Bridge;
using System;

namespace Logging
{
    public static class Logger
    {
        private static readonly Action<object> DebugAction;
        private static readonly Action<object> InfoAction;
        private static readonly Action<object> WarnAction;
        private static readonly Action<object> ErrorAction;

        static Logger()
        {
            if (Script.Eval<bool>("console.debug")) DebugAction = Script.Eval<Action<object>>("console.debug");
            if (Script.Eval<bool>("console.info")) InfoAction = Script.Eval<Action<object>>("console.info");
            if (Script.Eval<bool>("console.warn")) WarnAction = Script.Eval<Action<object>>("console.warn");
            if (Script.Eval<bool>("console.error")) ErrorAction = Script.Eval<Action<object>>("console.error");
#if DEBUG
            DebugAction?.Invoke("Debug log Test");
            InfoAction?.Invoke("Info log Test");
            WarnAction?.Invoke("Warn log Test");
            ErrorAction?.Invoke("Err log Test");
#endif
        }

        public static bool EnableDebug;

        public static void Debug(object message)
        {
            if (EnableDebug) DebugAction?.Invoke(message);
        }

        public static void Info(object message) => InfoAction?.Invoke(message);

        public static void Warn(object message) => WarnAction?.Invoke(message);

        public static void Error(object message) => ErrorAction?.Invoke(message);
    }
}